//+------------------------------------------------------------------+
//|                  Run Script And Change Template.mq4              |
//+------------------------------------------------------------------+
// based on http://www.forexfactory.com/showthread.php?p=4745795 #post4745795 and  http://codebase.mql4.com/source/13027
// see also: http://articles.mql4.com/477

#property copyright "Copyright  2011"
#property show_inputs

#define PAUSE 500 // 10
#define VK_MENU 0x12 //ALT key
#define VK_CONTROL 0x11 //CTRL key
 
#include <WinUser32.mqh>

#import "user32.dll"
   int      PostMessageA(int hWnd,int Msg,int wParam,int lParam);
   int      GetWindow(int hWnd,int uCmd);
   int      GetParent(int hWnd);
#import

// hotkey to start the script, must be assigned to the script first
// if CtrlAlt = 1 and Key = "Q" the ea will emulate the press of "Alt+Q":
   int     CtrlAlt=1; // 0 - Ctrl, 1 - Alt
   string  Key="Q";

// which template to load?
extern string hi1="0: first template in the list, 1 the next, etc.";
extern int templateIndex = 0;
extern string hi2="true:change for all open charts, false: current chart only";
extern bool changeAll=false;

bool done = false;

int init()
{
return(0);
}

int deinit()
{
return(0);
}

int start()
{
RunScriptAndChangeTemplate();
}

void RunScriptAndChangeTemplate()
{
    int FirstKey=VK_CONTROL;
    if(CtrlAlt==1)FirstKey=VK_MENU;
    int SecondKey=StringGetChar(Key,0);

if (!done)
{ 
     keybd_event(FirstKey,0,0,0); // press 1. key
     Sleep(PAUSE);
     keybd_event(SecondKey,0,0,0); // press 2. key
     Sleep(PAUSE);
     keybd_event(SecondKey,0,2,0); // release 2. key
     Sleep(PAUSE);
     keybd_event(FirstKey,0,2,0);  // release 1. key
}
done = true;

   bool blnContinue = true;   
   int intParent = GetParent( WindowHandle( Symbol(), Period() ) );   
   int intChild = GetWindow( intParent, GW_HWNDFIRST );  

if (changeAll) {
   if ( intChild > 0 )   
   {
      if ( intChild != intParent )   PostMessageA( intChild, WM_COMMAND, 34800 + templateIndex, 0 );
   }
   else      blnContinue = false;   
   
   while( blnContinue )
   {
      intChild = GetWindow( intChild, GW_HWNDNEXT );   
   
      if ( intChild > 0 )   
      { 
         if ( intChild != intParent )   PostMessageA( intChild, WM_COMMAND, 34800 + templateIndex, 0 );
      }
      else   blnContinue = false;   
   }
 }//end if (changeAll)

// Now do the current window
PostMessageA( intParent, WM_COMMAND, 34800 + templateIndex, 0 );
}